#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x66TN1x1x6_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=66, 
 * lda=66, ldb=66, ldc=0, mu=1, nu=1, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.1)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (((Mb) << 6)+((Mb) << 1));
   const float *stN = B + (((Nb) << 6)+((Nb) << 1));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 0, incAn = -(((Mb) << 6)+((Mb) << 1));
   #define incBk 6
   const int incBm = -66, incBn = 66;
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=66; k; k -= 6) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_cJIK0x0x66TN6x1x6_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=66, 
 * lda=66, ldb=66, ldc=0, mu=6, nu=1, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.1)
 */
{
   const int Mb = (M/6)*6;
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 6)+((Mb) << 1));
   const float *stN = B + (((Nb) << 6)+((Nb) << 1));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 330, incAn = -(((Mb) << 6)+((Mb) << 1));
   #define incBk 6
   const int incBm = -66, incBn = 66;
   #define incCm 12
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
            rC2_0 = pC0[4];
            rC2_0 *= rA0;
            rC3_0 = pC0[6];
            rC3_0 *= rA0;
            rC4_0 = pC0[8];
            rC4_0 *= rA0;
            rC5_0 = pC0[10];
            rC5_0 *= rA0;
            for (k=66; k; k -= 6) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[66];
               rA2 = pA0[132];
               rA3 = pA0[198];
               rA4 = pA0[264];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[330];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[67];
               rA2 = pA0[133];
               rA3 = pA0[199];
               rA4 = pA0[265];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[331];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[68];
               rA2 = pA0[134];
               rA3 = pA0[200];
               rA4 = pA0[266];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[332];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[69];
               rA2 = pA0[135];
               rA3 = pA0[201];
               rA4 = pA0[267];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[333];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[70];
               rA2 = pA0[136];
               rA3 = pA0[202];
               rA4 = pA0[268];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[334];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[71];
               rA2 = pA0[137];
               rA3 = pA0[203];
               rA4 = pA0[269];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[335];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            pC0[8] = rC4_0;
            pC0[10] = rC5_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_cJIK0x0x66TN1x1x6_a1_bX(k, N, 66, alpha, ca + (((Mb) << 6)+((Mb) << 1)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x66TN1x3x6_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=66, 
 * lda=66, ldb=66, ldc=0, mu=1, nu=3, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.1)
 */
{
   #define Mb M
   const int Nb = (N/3)*3;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 6)+((Mb) << 1));
   const float *stN = B + (((Nb) << 6)+((Nb) << 1));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*3)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 0, incAn = -(((Mb) << 6)+((Mb) << 1));
   #define incBk 6
   const int incBm = -66, incBn = 198;
   #define incCm 2
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2;
   register float rC0_0, rC0_1, rC0_2;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            for (k=66; k; k -= 6) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = pB0[66];
               rB2 = pB0[132];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB0[67];
               rB2 = pB0[133];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rB1 = pB0[68];
               rB2 = pB0[134];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rB1 = pB0[69];
               rB2 = pB0[135];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rB1 = pB0[70];
               rB2 = pB0[136];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rB1 = pB0[71];
               rB2 = pB0[137];
               rC0_0 += rA0 * rB0;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_cJIK0x0x66TN1x1x6_a1_bX(M, k, 66, alpha, ca, lda, cb + (((Nb) << 6)+((Nb) << 1)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK0x0x66TN66x66x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=66, 
 * lda=66, ldb=66, ldc=0, mu=6, nu=3, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.1)
 */
{
   const int Mb = (M/6)*6;
   const int Nb = (N/3)*3;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 6)+((Mb) << 1));
   const float *stN = B + (((Nb) << 6)+((Nb) << 1));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*3)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 330, incAn = -(((Mb) << 6)+((Mb) << 1));
   #define incBk 6
   const int incBm = -66, incBn = 198;
   #define incCm 12
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5;
   register float rB0, rB1, rB2;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            do /* M-loop */
            {
               ATL_pfl1R(pfA);
               pfA += incPFA;
               rA0 = beta;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[2];
               rC1_0 *= rA0;
               rC2_0 = pC0[4];
               rC2_0 *= rA0;
               rC3_0 = pC0[6];
               rC3_0 *= rA0;
               rC4_0 = pC0[8];
               rC4_0 *= rA0;
               rC5_0 = pC0[10];
               rC5_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[2];
               rC1_1 *= rA0;
               rC2_1 = pC1[4];
               rC2_1 *= rA0;
               rC3_1 = pC1[6];
               rC3_1 *= rA0;
               rC4_1 = pC1[8];
               rC4_1 *= rA0;
               rC5_1 = pC1[10];
               rC5_1 *= rA0;
               rC0_2 = *pC2;
               rC0_2 *= rA0;
               rC1_2 = pC2[2];
               rC1_2 *= rA0;
               rC2_2 = pC2[4];
               rC2_2 *= rA0;
               rC3_2 = pC2[6];
               rC3_2 *= rA0;
               rC4_2 = pC2[8];
               rC4_2 *= rA0;
               rC5_2 = pC2[10];
               rC5_2 *= rA0;
               for (k=66; k; k -= 6) /* easy loop to unroll */
               {
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[66];
                  rA2 = pA0[132];
                  rA3 = pA0[198];
                  rA4 = pA0[264];
                  rC0_0 += rA0 * rB0;
                  rA5 = pA0[330];
                  rB1 = pB0[66];
                  rC1_0 += rA1 * rB0;
                  rB2 = pB0[132];
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC4_0 += rA4 * rB0;
                  rC5_0 += rA5 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC4_1 += rA4 * rB1;
                  rC5_1 += rA5 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rC4_2 += rA4 * rB2;
                  rC5_2 += rA5 * rB2;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA0[67];
                  rA2 = pA0[133];
                  rA3 = pA0[199];
                  rA4 = pA0[265];
                  rC0_0 += rA0 * rB0;
                  rA5 = pA0[331];
                  rB1 = pB0[67];
                  rC1_0 += rA1 * rB0;
                  rB2 = pB0[133];
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC4_0 += rA4 * rB0;
                  rC5_0 += rA5 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC4_1 += rA4 * rB1;
                  rC5_1 += rA5 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rC4_2 += rA4 * rB2;
                  rC5_2 += rA5 * rB2;
                  rA0 = pA0[2];
                  rB0 = pB0[2];
                  rA1 = pA0[68];
                  rA2 = pA0[134];
                  rA3 = pA0[200];
                  rA4 = pA0[266];
                  rC0_0 += rA0 * rB0;
                  rA5 = pA0[332];
                  rB1 = pB0[68];
                  rC1_0 += rA1 * rB0;
                  rB2 = pB0[134];
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC4_0 += rA4 * rB0;
                  rC5_0 += rA5 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC4_1 += rA4 * rB1;
                  rC5_1 += rA5 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rC4_2 += rA4 * rB2;
                  rC5_2 += rA5 * rB2;
                  rA0 = pA0[3];
                  rB0 = pB0[3];
                  rA1 = pA0[69];
                  rA2 = pA0[135];
                  rA3 = pA0[201];
                  rA4 = pA0[267];
                  rC0_0 += rA0 * rB0;
                  rA5 = pA0[333];
                  rB1 = pB0[69];
                  rC1_0 += rA1 * rB0;
                  rB2 = pB0[135];
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC4_0 += rA4 * rB0;
                  rC5_0 += rA5 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC4_1 += rA4 * rB1;
                  rC5_1 += rA5 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rC4_2 += rA4 * rB2;
                  rC5_2 += rA5 * rB2;
                  rA0 = pA0[4];
                  rB0 = pB0[4];
                  rA1 = pA0[70];
                  rA2 = pA0[136];
                  rA3 = pA0[202];
                  rA4 = pA0[268];
                  rC0_0 += rA0 * rB0;
                  rA5 = pA0[334];
                  rB1 = pB0[70];
                  rC1_0 += rA1 * rB0;
                  rB2 = pB0[136];
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC4_0 += rA4 * rB0;
                  rC5_0 += rA5 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC4_1 += rA4 * rB1;
                  rC5_1 += rA5 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rC4_2 += rA4 * rB2;
                  rC5_2 += rA5 * rB2;
                  rA0 = pA0[5];
                  rB0 = pB0[5];
                  rA1 = pA0[71];
                  rA2 = pA0[137];
                  rA3 = pA0[203];
                  rA4 = pA0[269];
                  rC0_0 += rA0 * rB0;
                  rA5 = pA0[335];
                  rB1 = pB0[71];
                  rC1_0 += rA1 * rB0;
                  rB2 = pB0[137];
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC4_0 += rA4 * rB0;
                  rC5_0 += rA5 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC4_1 += rA4 * rB1;
                  rC5_1 += rA5 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rC4_2 += rA4 * rB2;
                  rC5_2 += rA5 * rB2;
                  pA0 += incAk;
                  pB0 += incBk;
               }
               *pC0 = rC0_0;
               pC0[2] = rC1_0;
               pC0[4] = rC2_0;
               pC0[6] = rC3_0;
               pC0[8] = rC4_0;
               pC0[10] = rC5_0;
               *pC1 = rC0_1;
               pC1[2] = rC1_1;
               pC1[4] = rC2_1;
               pC1[6] = rC3_1;
               pC1[8] = rC4_1;
               pC1[10] = rC5_1;
               *pC2 = rC0_2;
               pC2[2] = rC1_2;
               pC2[4] = rC2_2;
               pC2[6] = rC3_2;
               pC2[8] = rC4_2;
               pC2[10] = rC5_2;
               pC0 += incCm;
               pC1 += incCm;
               pC2 += incCm;
               pA0 += incAm;
               pB0 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pC2 += incCn;
            pA0 += incAn;
            pB0 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_cJIK0x0x66TN6x1x6_a1_bX(M, k, 66, alpha, ca, lda, cb + (((Nb) << 6)+((Nb) << 1)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
   if (Nb && (k=M-Mb))
      ATL_cJIK0x0x66TN1x3x6_a1_bX(k, Nb, 66, alpha, ca + (((Mb) << 6)+((Mb) << 1)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
