#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK72x0x72TN6x1x6_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=72, NB=0, KB=72, 
 * lda=72, ldb=72, ldc=0, mu=6, nu=1, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.1)
 */
{
   #define Nb N
   const float *stM = A + 5184;
   const float *stN = B + (((Nb) << 6)+((Nb) << 3));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*1)/(72*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 360, incAn = -5184;
   #define incBk 6
   const int incBm = -72, incBn = 72;
   #define incCm 12
   const int incCn = (((ldc) << 1)) - 144;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rC0_0 = rC1_0 = rC2_0 = rC3_0 = rC4_0 = rC5_0 = 0.0;
         for (k=72; k; k -= 6) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[72];
            rA2 = pA0[144];
            rA3 = pA0[216];
            rA4 = pA0[288];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[360];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rA1 = pA0[73];
            rA2 = pA0[145];
            rA3 = pA0[217];
            rA4 = pA0[289];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[361];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rA1 = pA0[74];
            rA2 = pA0[146];
            rA3 = pA0[218];
            rA4 = pA0[290];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[362];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rA1 = pA0[75];
            rA2 = pA0[147];
            rA3 = pA0[219];
            rA4 = pA0[291];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[363];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rA1 = pA0[76];
            rA2 = pA0[148];
            rA3 = pA0[220];
            rA4 = pA0[292];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[364];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rA1 = pA0[77];
            rA2 = pA0[149];
            rA3 = pA0[221];
            rA4 = pA0[293];
            rC0_0 += rA0 * rB0;
            rA5 = pA0[365];
            rC1_0 += rA1 * rB0;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         pC0[10] = rC5_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK72x0x72TN72x72x0_a1_b0
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=72, NB=0, KB=72, 
 * lda=72, ldb=72, ldc=0, mu=6, nu=3, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.1)
 */
{
   const int Nb = (N/3)*3;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 5184;
   const float *stN = B + (((Nb) << 6)+((Nb) << 3));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*6*3)/(72*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 360, incAn = -5184;
   #define incBk 6
   const int incBm = -72, incBn = 216;
   #define incCm 12
   const int incCn = (((ldc) << 2)+((ldc) << 1)) - 144;
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3, rA4, rA5;
   register float rB0, rB1, rB2;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rC0_0 = rC1_0 = rC2_0 = rC3_0 = rC4_0 = rC5_0 = rC0_1 = rC1_1 = rC2_1 = rC3_1 = rC4_1 = rC5_1 = rC0_2 = rC1_2 = rC2_2 = rC3_2 = rC4_2 = rC5_2 = 0.0;
            for (k=72; k; k -= 6) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[72];
               rA2 = pA0[144];
               rA3 = pA0[216];
               rA4 = pA0[288];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[360];
               rB1 = pB0[72];
               rC1_0 += rA1 * rB0;
               rB2 = pB0[144];
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC5_1 += rA5 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC5_2 += rA5 * rB2;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[73];
               rA2 = pA0[145];
               rA3 = pA0[217];
               rA4 = pA0[289];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[361];
               rB1 = pB0[73];
               rC1_0 += rA1 * rB0;
               rB2 = pB0[145];
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC5_1 += rA5 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC5_2 += rA5 * rB2;
               rA0 = pA0[2];
               rB0 = pB0[2];
               rA1 = pA0[74];
               rA2 = pA0[146];
               rA3 = pA0[218];
               rA4 = pA0[290];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[362];
               rB1 = pB0[74];
               rC1_0 += rA1 * rB0;
               rB2 = pB0[146];
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC5_1 += rA5 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC5_2 += rA5 * rB2;
               rA0 = pA0[3];
               rB0 = pB0[3];
               rA1 = pA0[75];
               rA2 = pA0[147];
               rA3 = pA0[219];
               rA4 = pA0[291];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[363];
               rB1 = pB0[75];
               rC1_0 += rA1 * rB0;
               rB2 = pB0[147];
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC5_1 += rA5 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC5_2 += rA5 * rB2;
               rA0 = pA0[4];
               rB0 = pB0[4];
               rA1 = pA0[76];
               rA2 = pA0[148];
               rA3 = pA0[220];
               rA4 = pA0[292];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[364];
               rB1 = pB0[76];
               rC1_0 += rA1 * rB0;
               rB2 = pB0[148];
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC5_1 += rA5 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC5_2 += rA5 * rB2;
               rA0 = pA0[5];
               rB0 = pB0[5];
               rA1 = pA0[77];
               rA2 = pA0[149];
               rA3 = pA0[221];
               rA4 = pA0[293];
               rC0_0 += rA0 * rB0;
               rA5 = pA0[365];
               rB1 = pB0[77];
               rC1_0 += rA1 * rB0;
               rB2 = pB0[149];
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               rC5_0 += rA5 * rB0;
               rC0_1 += rA0 * rB1;
               rC1_1 += rA1 * rB1;
               rC2_1 += rA2 * rB1;
               rC3_1 += rA3 * rB1;
               rC4_1 += rA4 * rB1;
               rC5_1 += rA5 * rB1;
               rC0_2 += rA0 * rB2;
               rC1_2 += rA1 * rB2;
               rC2_2 += rA2 * rB2;
               rC3_2 += rA3 * rB2;
               rC4_2 += rA4 * rB2;
               rC5_2 += rA5 * rB2;
               pA0 += incAk;
               pB0 += incBk;
            }
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            pC0[8] = rC4_0;
            pC0[10] = rC5_0;
            *pC1 = rC0_1;
            pC1[2] = rC1_1;
            pC1[4] = rC2_1;
            pC1[6] = rC3_1;
            pC1[8] = rC4_1;
            pC1[10] = rC5_1;
            *pC2 = rC0_2;
            pC2[2] = rC1_2;
            pC2[4] = rC2_2;
            pC2[6] = rC3_2;
            pC2[8] = rC4_2;
            pC2[10] = rC5_2;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_cJIK72x0x72TN6x1x6_a1_b0(72, k, 72, alpha, ca, lda, cb + (((Nb) << 6)+((Nb) << 3)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_cpNBmm_b0 ATL_cgpNBmm_b0
#endif

void ATL_cJIK72x0x72TN72x72x0_a1_b0(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK72x0x72TN72x72x0_a1_bX(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);
void ATL_cJIK72x0x72TN72x72x0_a1_b1(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc);

void ATL_cpNBmm_b0(const int M, const int N, const int K, const float alpha, const float *A, const int lda, const float *B, const int ldb, const float beta, float *C, const int ldc)
{
   ATL_cJIK72x0x72TN72x72x0_a1_b0(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_cJIK72x0x72TN72x72x0_a1_b0(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_cJIK72x0x72TN72x72x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_cJIK72x0x72TN72x72x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
